#!/bin/sh
#
# QLogic ISP2x00 device driver dump reader
# Copyright (c) 2003-2011 QLogic Corporation
#
# See LICENSE.qla2xxx for copyright and licensing details.
#
version=1.039720
sysfs=/sys
qstats=${sysfs}/class/scsi_host/host${1}/device/stats
qfwd=${sysfs}/class/scsi_host/host${1}/device/fw_dump
dfile=fw_dump_${1}_`eval date +%Y%m%d_%H%M%S`.txt

# Get host number
if [ -z "${1}" ] ; then
	echo "QLogic Firmware Dump Reader: ${version}"
	echo "Usage:"
	echo "   `basename ${0}` <host_no>"
	exit 1
fi

# Verify fw_dump binary-attribute file
if ! test -f ${qfwd} ; then
	echo "No firmware dump file at host ${1}!!!"
	exit 1
fi

# Verify a firmware dump is available for the given host
#if ! test -f ${qstats} ; then
#	echo "No device stats to verify firmware dump available at host ${1}!!!"
#	exit 1
#fi
#do_dump=`eval cat ${qstats} | cut -d ' ' -f5`
#if [ "${do_dump}" = "0" ] ; then
#	echo "No firmware dump available at host ${1}!!!"
#	exit 1
#fi

# Go with dump
echo 1 > ${qfwd}
cat ${qfwd} > ${dfile}
echo 0 > ${qfwd}
if ! test -s "${dfile}" ; then
	echo "No firmware dump available at host ${1}!!!"
	rm ${dfile}
	exit 1
fi

gzip ${dfile}
echo "Firmware dumped to file ${dfile}.gz."

exit 0
